/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumComparator;
import de.ship.db.tables.records.VCoreLogiccondRecord;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreLogiccond extends TableImpl<VCoreLogiccondRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_logiccond</code>
     */
    public static final VCoreLogiccond V_CORE_LOGICCOND = new VCoreLogiccond();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreLogiccondRecord> getRecordType() {
        return VCoreLogiccondRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_logiccond.lastchange</code>.
     */
    public final TableField<VCoreLogiccondRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6), this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.pk</code>.
     */
    public final TableField<VCoreLogiccondRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.fk_andgrp</code>.
     */
    public final TableField<VCoreLogiccondRecord, Integer> FK_ANDGRP = createField(DSL.name("fk_andgrp"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.fk_left_element</code>.
     */
    public final TableField<VCoreLogiccondRecord, Integer> FK_LEFT_ELEMENT = createField(DSL.name("fk_left_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.left_depth</code>.
     */
    public final TableField<VCoreLogiccondRecord, Integer> LEFT_DEPTH = createField(DSL.name("left_depth"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.right_value</code>.
     */
    public final TableField<VCoreLogiccondRecord, BigDecimal> RIGHT_VALUE = createField(DSL.name("right_value"), SQLDataType.NUMERIC, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.fk_right_element</code>.
     */
    public final TableField<VCoreLogiccondRecord, Integer> FK_RIGHT_ELEMENT = createField(DSL.name("fk_right_element"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.right_depth</code>.
     */
    public final TableField<VCoreLogiccondRecord, Integer> RIGHT_DEPTH = createField(DSL.name("right_depth"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.comparator</code>.
     */
    public final TableField<VCoreLogiccondRecord, EnumComparator> COMPARATOR = createField(DSL.name("comparator"), SQLDataType.VARCHAR.asEnumDataType(EnumComparator.class), this, "");

    /**
     * The column <code>common_dd.v_core_logiccond.compare_variables</code>.
     */
    public final TableField<VCoreLogiccondRecord, Boolean> COMPARE_VARIABLES = createField(DSL.name("compare_variables"), SQLDataType.BOOLEAN, this, "");

    private VCoreLogiccond(Name alias, Table<VCoreLogiccondRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreLogiccond(Name alias, Table<VCoreLogiccondRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_logiccond" as  SELECT lastchange,
         pk_core_logiccond AS pk,
         fk_andgrp,
         fk_variable AS fk_left_element,
         depth AS left_depth,
         logiccond_value AS right_value,
         fk_variable2 AS fk_right_element,
         depth2 AS right_depth,
         (logiccond_comparator)::common_dd.enum_comparator AS comparator,
             CASE compare_variables
                 WHEN 1 THEN true
                 WHEN 0 THEN false
                 ELSE NULL::boolean
             END AS compare_variables
        FROM common_dd.t_core_logiccond;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_logiccond</code> table reference
     */
    public VCoreLogiccond(String alias) {
        this(DSL.name(alias), V_CORE_LOGICCOND);
    }

    /**
     * Create an aliased <code>common_dd.v_core_logiccond</code> table reference
     */
    public VCoreLogiccond(Name alias) {
        this(alias, V_CORE_LOGICCOND);
    }

    /**
     * Create a <code>common_dd.v_core_logiccond</code> table reference
     */
    public VCoreLogiccond() {
        this(DSL.name("v_core_logiccond"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreLogiccond as(String alias) {
        return new VCoreLogiccond(DSL.name(alias), this);
    }

    @Override
    public VCoreLogiccond as(Name alias) {
        return new VCoreLogiccond(alias, this);
    }

    @Override
    public VCoreLogiccond as(Table<?> alias) {
        return new VCoreLogiccond(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLogiccond rename(String name) {
        return new VCoreLogiccond(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLogiccond rename(Name name) {
        return new VCoreLogiccond(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLogiccond rename(Table<?> name) {
        return new VCoreLogiccond(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogiccond where(Condition condition) {
        return new VCoreLogiccond(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogiccond where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogiccond where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogiccond where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogiccond where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogiccond where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogiccond where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLogiccond where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogiccond whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLogiccond whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
